| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Private Attributes | List of all members
GaudiHandleArray< T > Class Template Reference

T is the concrete handle type, e.g. More...

`#include <GaudiKernel/GaudiHandle.h>`

Inheritance diagram for GaudiHandleArray< T >:
[legend]
Collaboration diagram for GaudiHandleArray< T >:
[legend]

## Public Types
typedef std::vector< T > | HandleVector
typedef HandleVector::value_type | value_type
typedef HandleVector::size_type | size_type
typedef HandleVector::reference | reference
typedef HandleVector::const_reference | const_reference
typedef HandleVector::iterator | iterator
typedef HandleVector::const_iterator | const_iterator
typedef HandleVector::reverse_iterator | reverse_iterator
typedef HandleVector::const_reverse_iterator | const_reverse_iterator
Public Types inherited from GaudiHandleArrayBase
typedef std::vector< GaudiHandleBase * > | BaseHandleArray
typedef std::vector< const GaudiHandleBase * > | ConstBaseHandleArray

## Public Member Functions
virtual | ~GaudiHandleArray ()=default
GaudiHandleArray & | operator= (const std::vector< std::string > &myTypesAndNamesList)
| Set the array of GaudiHandles from typeAndNames given in vector of strings. More...
GaudiHandleArrayBase::BaseHandleArray | getBaseArray () override
| Get a read-write vector of GaudiHandleBase* pointing to the real handles. More...
GaudiHandleArrayBase::ConstBaseHandleArray | getBaseArray () const override
| Get a read-only vector of const GaudiHandleBase* pointing to the real handles. More...
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
const_iterator | rbegin () const
const_iterator | rend () const
size_type | size () const
void | clear () override
| Clear the list of handles. More...
bool | empty () const override
| Return whether the list of tools is empty. More...
T & | operator[] (int index)
const T & | operator[] (int index) const
T * | operator[] (const std::string &name)
| Get pointer (!) to ToolHandle by instance name. More...
const T * | operator[] (const std::string &name) const
| Get const pointer (!) to ToolHandle by instance name. More...
virtual bool | push_back (const T &myHandle)
StatusCode | retrieve ()
| Retrieve all tools. More...
StatusCode | release ()
| Release all tools. More...
virtual bool | retrieved () const override
| has Array been retreived? More...
Public Member Functions inherited from GaudiHandleArrayBase
bool | setTypesAndNames (const std::vector< std::string > &myTypesAndNamesList)
| Set the array of handles from list of "type/name" strings in <myTypesAndNamesList>. More...
const std::vector< std::string > | typesAndNames () const
| Return a vector with "type/name" strings of all handles in the array. More...
const std::vector< std::string > | types () const
| Return a vector with "type" strings of all handles in the array. More...
const std::vector< std::string > | names () const
| Return a vector with "type/name" strings of all handles in the array. More...
const std::vector< std::string > | getBaseInfos (std::string(GaudiHandleBase::*pMemFunc)() const ) const
| Helper function to get a vector of strings filled with the return value of each tool of a member function if GaudiHandleBase. More...
std::string | pythonPropertyClassName () const override
| Name of the componentType with "HandleArray" appended. More...
std::string | pythonRepr () const override
| Python representation of array of handles, i.e. More...
virtual bool | push_back (const std::string &myHandleTypeAndName)=0
| Add a handle to the array with "type/name" given in <myHandleTypeAndName>. More...
Public Member Functions inherited from GaudiHandleInfo
virtual | ~GaudiHandleInfo ()=default
| virtual destructor so that derived class destructor is called. More...
const std::string & | componentType () const
const std::string & | propertyName () const
| name as used in declareProperty(name,gaudiHandle) More...
void | setPropertyName (std::string propName)
| set name as used in declareProperty(name,gaudiHandle). More...
const std::string & | parentName () const
| The name of the parent. More...

## Protected Member Functions
| GaudiHandleArray (const std::vector< std::string > &myTypesAndNamesList, std::string myComponentType, std::string myParentName)
| Generic constructor. More...
| GaudiHandleArray (const std::string &myComponentType, const std::string &myParentName)
| Constructor creating an empty array. More...
Protected Member Functions inherited from GaudiHandleArrayBase
| GaudiHandleArrayBase (std::string myComponentType, std::string myParentName)
Protected Member Functions inherited from GaudiHandleInfo
| GaudiHandleInfo (std::string myComponentType, std::string myParentName)
| Some basic information and helper functions shared between various handles/arrays. More...
void | setComponentType (const std::string &componentType)
| The component type. More...
void | setParentName (const std::string &parent)
| The name of the parent. More...

## Private Attributes
HandleVector | m_handleArray
bool | m_retrieved { false }

## Detailed Description

### template<class T>
class GaudiHandleArray< T >

T is the concrete handle type, e.g.

ToolHandle<IMyTool>

Definition at line 428 of file GaudiHandle.h.

## Member Typedef Documentation

template<class T>

typedef HandleVector::const_iterator GaudiHandleArray< T >::const_iterator

Definition at line 439 of file GaudiHandle.h.

template<class T>

typedef HandleVector::const_reference GaudiHandleArray< T >::const_reference

Definition at line 437 of file GaudiHandle.h.

template<class T>

typedef HandleVector::const_reverse_iterator GaudiHandleArray< T >::const_reverse_iterator

Definition at line 441 of file GaudiHandle.h.

template<class T>

typedef std::vector< T > GaudiHandleArray< T >::HandleVector

Definition at line 433 of file GaudiHandle.h.

template<class T>

typedef HandleVector::iterator GaudiHandleArray< T >::iterator

Definition at line 438 of file GaudiHandle.h.

template<class T>

typedef HandleVector::reference GaudiHandleArray< T >::reference

Definition at line 436 of file GaudiHandle.h.

template<class T>

typedef HandleVector::reverse_iterator GaudiHandleArray< T >::reverse_iterator

Definition at line 440 of file GaudiHandle.h.

template<class T>

typedef HandleVector::size_type GaudiHandleArray< T >::size_type

Definition at line 435 of file GaudiHandle.h.

template<class T>

typedef HandleVector::value_type GaudiHandleArray< T >::value_type

Definition at line 434 of file GaudiHandle.h.

## Constructor & Destructor Documentation

template<class T>

GaudiHandleArray< T >::GaudiHandleArray | ( | const std::vector< std::string > & | myTypesAndNamesList,
|  | std::string | myComponentType,
|  | std::string | myParentName
| ) |  |
| inline protected

Generic constructor.

Probably not very useful...

Parameters

  typesAndNamesList | : a vector of strings with the concrete "type/name" strings for the list of tools

Definition at line 451 of file GaudiHandle.h.

453 : GaudiHandleArrayBase(std::move(myComponentType),std::move(myParentName))
454 {
455 setTypesAndNames( myTypesAndNamesList );
456 }
GaudiHandleArrayBase::setTypesAndNames
bool setTypesAndNames(const std::vector< std::string > &myTypesAndNamesList)
Set the array of handles from list of "type/name" strings in <myTypesAndNamesList>.
Definition: GaudiHandle.cpp:63
std::move
T move(T...args)
GaudiHandleArrayBase::GaudiHandleArrayBase
GaudiHandleArrayBase(std::string myComponentType, std::string myParentName)
Definition: GaudiHandle.h:366
template<class T>

GaudiHandleArray< T >::GaudiHandleArray | ( | const std::string & | myComponentType,
|  | const std::string & | myParentName
| ) |  |
| inline protected

Constructor creating an empty array.

Parameters

  typesAndNamesList | : a vector of strings with the concrete "type/name" strings for the list of tools

Definition at line 462 of file GaudiHandle.h.

463 : GaudiHandleArrayBase(myComponentType,myParentName)
464 {}
GaudiHandleArrayBase::GaudiHandleArrayBase
GaudiHandleArrayBase(std::string myComponentType, std::string myParentName)
Definition: GaudiHandle.h:366
template<class T>

virtual GaudiHandleArray< T >::~GaudiHandleArray | ( |  | ) |
| virtual default

## Member Function Documentation

template<class T>

iterator GaudiHandleArray< T >::begin | ( |  | ) |
| inline

Definition at line 492 of file GaudiHandle.h.

492 {
493 return m_handleArray.begin();
494 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
std::vector::begin
T begin(T...args)
template<class T>

const_iterator GaudiHandleArray< T >::begin | ( |  | ) | const
| inline

Definition at line 500 of file GaudiHandle.h.

500 {
501 return m_handleArray.begin();
502 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
std::vector::begin
T begin(T...args)
template<class T>

void GaudiHandleArray< T >::clear | ( |  | ) |
| inline override virtual

Clear the list of handles.

Implemented in GaudiHandleArray

Implements GaudiHandleArrayBase.

Definition at line 520 of file GaudiHandle.h.

520 {
521 m_handleArray.clear();
522 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
std::vector::clear
T clear(T...args)
template<class T>

bool GaudiHandleArray< T >::empty | ( |  | ) | const
| inline override virtual

Return whether the list of tools is empty.

Implements GaudiHandleArrayBase.

Definition at line 524 of file GaudiHandle.h.

524 {
525 return m_handleArray.empty();
526 }
std::vector::empty
T empty(T...args)
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

iterator GaudiHandleArray< T >::end | ( |  | ) |
| inline

Definition at line 496 of file GaudiHandle.h.

496 {
497 return m_handleArray.end();
498 }
std::vector::end
T end(T...args)
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

const_iterator GaudiHandleArray< T >::end | ( |  | ) | const
| inline

Definition at line 504 of file GaudiHandle.h.

504 {
505 return m_handleArray.end();
506 }
std::vector::end
T end(T...args)
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

GaudiHandleArrayBase::BaseHandleArray GaudiHandleArray< T >::getBaseArray | ( |  | ) |
| inline override virtual

Get a read-write vector of GaudiHandleBase* pointing to the real handles.

Implemented in GaudiHandleArray.

Implements GaudiHandleArrayBase.

Definition at line 475 of file GaudiHandle.h.

475 {
476 GaudiHandleArrayBase::BaseHandleArray baseArray;
477 iterator it = begin(), itEnd = end();
478 for ( ; it != itEnd; ++it ) baseArray.push_back( &*it );
479 return baseArray;
480 }
GaudiHandleArray::iterator
HandleVector::iterator iterator
Definition: GaudiHandle.h:438
std::vector::push_back
T push_back(T...args)
GaudiHandleArray::begin
iterator begin()
Definition: GaudiHandle.h:492
std::vector
STL class.
GaudiHandleArray::end
iterator end()
Definition: GaudiHandle.h:496
template<class T>

GaudiHandleArrayBase::ConstBaseHandleArray GaudiHandleArray< T >::getBaseArray | ( |  | ) | const
| inline override virtual

Get a read-only vector of const GaudiHandleBase* pointing to the real handles.

Implemented in GaudiHandleArray.

Implements GaudiHandleArrayBase.

Definition at line 482 of file GaudiHandle.h.

482 {
483 GaudiHandleArrayBase::ConstBaseHandleArray baseArray;
484 const_iterator it = begin(), itEnd = end();
485 for ( ; it != itEnd; ++it ) baseArray.push_back( &*it );
486 return baseArray;
487 }
std::vector::push_back
T push_back(T...args)
GaudiHandleArray::begin
iterator begin()
Definition: GaudiHandle.h:492
GaudiHandleArray::const_iterator
HandleVector::const_iterator const_iterator
Definition: GaudiHandle.h:439
std::vector
STL class.
GaudiHandleArray::end
iterator end()
Definition: GaudiHandle.h:496
template<class T>

GaudiHandleArray& GaudiHandleArray< T >::operator= | ( | const std::vector< std::string > & | myTypesAndNamesList | ) |
| inline

Set the array of GaudiHandles from typeAndNames given in vector of strings.

Definition at line 470 of file GaudiHandle.h.

470 {
471 setTypesAndNames( myTypesAndNamesList );
472 return *this;
473 }
GaudiHandleArrayBase::setTypesAndNames
bool setTypesAndNames(const std::vector< std::string > &myTypesAndNamesList)
Set the array of handles from list of "type/name" strings in <myTypesAndNamesList>.
Definition: GaudiHandle.cpp:63
template<class T>

T& GaudiHandleArray< T >::operator[] | ( | int | index | ) |
| inline

Definition at line 528 of file GaudiHandle.h.

528 {
529 return m_handleArray[index];
530 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

const T& GaudiHandleArray< T >::operator[] | ( | int | index | ) | const
| inline

Definition at line 532 of file GaudiHandle.h.

532 {
533 return m_handleArray[index];
534 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

T* GaudiHandleArray< T >::operator[] | ( | const std::string & | name | ) |
| inline

Get pointer (!) to ToolHandle by instance name.

Returns zero pointer if not found

Definition at line 537 of file GaudiHandle.h.

537 {
538 auto it = std::find_if(begin(),end(),[&](const_reference r) {
539 return r.name() == name;
540 } );
541 return it != end() ? &*it : nullptr;
542 }
GaudiHandleArray::const_reference
HandleVector::const_reference const_reference
Definition: GaudiHandle.h:437
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:28
GaudiHandleArray::begin
iterator begin()
Definition: GaudiHandle.h:492
std::find_if
T find_if(T...args)
GaudiHandleArray::end
iterator end()
Definition: GaudiHandle.h:496
template<class T>

const T* GaudiHandleArray< T >::operator[] | ( | const std::string & | name | ) | const
| inline

Get const pointer (!) to ToolHandle by instance name.

Returns zero pointer if not found

Definition at line 545 of file GaudiHandle.h.

545 {
546 auto it = std::find_if(begin(),end(),[&](const_reference r) {
547 return r.name() == name;
548 } );
549 return it != end() ? &*it : nullptr;
550 }
GaudiHandleArray::const_reference
HandleVector::const_reference const_reference
Definition: GaudiHandle.h:437
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:28
GaudiHandleArray::begin
iterator begin()
Definition: GaudiHandle.h:492
std::find_if
T find_if(T...args)
GaudiHandleArray::end
iterator end()
Definition: GaudiHandle.h:496
template<class T>

virtual bool GaudiHandleArray< T >::push_back | ( | const T & | myHandle | ) |
| inline virtual

Reimplemented in ToolHandleArray< T >, ToolHandleArray< IThreadInitTool >, and ServiceHandleArray< T >.

Definition at line 555 of file GaudiHandle.h.

555 {
556 m_handleArray.push_back( myHandle );
557 return true;
558 }
std::vector::push_back
T push_back(T...args)
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

const_iterator GaudiHandleArray< T >::rbegin | ( |  | ) | const
| inline

Definition at line 508 of file GaudiHandle.h.

508 {
509 return m_handleArray.rbegin();
510 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
std::vector::rbegin
T rbegin(T...args)
template<class T>

StatusCode GaudiHandleArray< T >::release | ( |  | ) |
| inline

Release all tools.

Definition at line 574 of file GaudiHandle.h.

574 {
575 StatusCode sc = StatusCode::SUCCESS;
576 for (auto& i : *this ) {
577 // continue trying to release other tools even if we fail...
578 if ( i.release().isFailure() ) sc = StatusCode::FAILURE;
579 }
580 return sc;
581 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
template<class T>

const_iterator GaudiHandleArray< T >::rend | ( |  | ) | const
| inline

Definition at line 512 of file GaudiHandle.h.

512 {
513 return m_handleArray.rend();
514 }
std::vector::rend
T rend(T...args)
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
template<class T>

StatusCode GaudiHandleArray< T >::retrieve | ( |  | ) |
| inline

Retrieve all tools.

Definition at line 561 of file GaudiHandle.h.

562 {
563 StatusCode sc = StatusCode::SUCCESS;
564 for ( auto& i : *this )
565 {
566 // stop at first failure
567 if ( i.retrieve().isFailure() ) { sc = StatusCode::FAILURE; break; }
568 }
569 if ( sc ) { m_retrieved = true; }
570 return sc;
571 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode::FAILURE
Definition: StatusCode.h:29
GaudiHandleArray::m_retrieved
bool m_retrieved
Definition: GaudiHandle.h:591
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
template<class T>

virtual bool GaudiHandleArray< T >::retrieved | ( |  | ) | const
| inline override virtual

has Array been retreived?

Implements GaudiHandleArrayBase.

Definition at line 584 of file GaudiHandle.h.

584 { return m_retrieved; }
GaudiHandleArray::m_retrieved
bool m_retrieved
Definition: GaudiHandle.h:591
template<class T>

size_type GaudiHandleArray< T >::size | ( |  | ) | const
| inline

Definition at line 516 of file GaudiHandle.h.

516 {
517 return m_handleArray.size();
518 }
GaudiHandleArray::m_handleArray
HandleVector m_handleArray
Definition: GaudiHandle.h:590
std::vector::size
T size(T...args)

## Member Data Documentation

template<class T>

HandleVector GaudiHandleArray< T >::m_handleArray
| private

Definition at line 590 of file GaudiHandle.h.

template<class T>

bool GaudiHandleArray< T >::m_retrieved { false }
| private

Definition at line 591 of file GaudiHandle.h.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/GaudiHandle.h